DataStructure_Algorithm_HandBook_PreForLeetCode

235. Lowest Common Ancestor of a Binary Search Tree

Given a binary search tree (BST), find the lowest common ancestor (LCA) node of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes p and q as the lowest node in T that has both p and q as descendants (where we allow a node to be a descendant of itself).”

Example 1:

img

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
Output: 6
Explanation: The LCA of nodes 2 and 8 is 6.

Example 2:

img

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4
Output: 2
Explanation: The LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.

Example 3:

Input: root = [2,1], p = 2, q = 1
Output: 2

Constraints:

solution

首先注意,这里是二叉搜索树,二茬搜索树的特点是对于任意一个节点,左边的都比他小,右边的都比他大。

如果说没有给到二叉搜索树的特性,那就是图论里面的经典问题了

但是这边给到了这个特性,那么可以很清楚的发现最近公共祖先满足的特点是大小位于两个节点之间。p < node < q 1
然后我们取一个深度最大的点即可。

如果找到的比当前的值大,就去左边找,反之就去右边找

var lowestCommonAncestor = function(root, p, q) {
    if (root.val > p.val && root.val > q.val) 
        return lowestCommonAncestor(root.left, p, q); // 返回左子树的递归调用结果
    if (root.val < p.val && root.val < q.val) 
        return lowestCommonAncestor(root.right, p, q); // 返回右子树的递归调用结果
    return root; // 当前节点是最近公共祖先
};